Summary: A free ipsec VPN solution for Linux
Name: freeswan
Version: 2.04
Release: 4tr
License: GPL
Group: Trustix Official
URL: http://www.freeswan.org
# The version of the X509 patch
%define x509version 1.4.8
Source0: ftp://ftp.xs4all.nl/pub/crypto/freeswan/freeswan-%{version}.tar.gz
Source1: freeswan-1.9.secrets.proto
Source3: http://www.strongsec.com/freeswan/x509-%{x509version}-freeswan-%{version}.tar.gz
Patch0: freeswan-2.00-init.patch
Patch1: freeswan-2.00-confused.patch
Patch2: freeswan-2.00-initdir.patch
Buildroot: /var/tmp/%{name}-root
Provides: vpn ipsec
PreReq: /sbin/chkconfig /sbin/restart_maybe


%description
Our project is Free S/WAN for Linux. Our overall goal is to make 
the Internet more secure and more private, to make Internet 
"wiretapping" entirely impractical.

IPSEC is designed to support (among other things) VPNs or virtual 
private networks, which allow multiple sites from an organisation
(optionally, and its clients, suppliers, etc.) to communicate 
securely over an insecure Internet by encrypting all communication 
between the sites. We want to extend that to a real private network 
in which anyone who choses to communicate securely can do so, 
in which strong encryption is universally available.

%prep
%setup -q

# For x509
tar -zxf %SOURCE3
patch -p1 <x509-%{x509version}-freeswan-%{version}/freeswan.diff
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf "$RPM_BUILD_ROOT"
CFLAGS="${RPM_OPT_FLAGS}"
make DESTDIR=/ \
     PUBDIR=/usr/sbin \
     BINDIR=/usr/lib/ipsec \
     MANTREE=/usr/share/man \
     INC_USRLOCAL=/usr \
     EXAMPLECONFDIR=/usr/share/doc/freeswan-%{version} \
     FINALDOCDIR=/usr/share/doc/freeswan-%{version} \
     FINALEXAMPLECONFDIR=/usr/share/doc/freeswan-%{version} \
     FINALLIBEXECDIR=/usr/lib/ipsec \
     RCDIR=%{_initdir} \
     MANTREE=%{_mandir} programs

%install
mkdir -p $RPM_BUILD_ROOT%{_initdir}
make DESTDIR=$RPM_BUILD_ROOT \
     PUBDIR=/usr/sbin \
     BINDIR=/usr/lib/ipsec \
     MANTREE=$RPM_BUILD_ROOT/usr/share/man \
     INC_USRLOCAL=/usr \
     EXAMPLECONFDIR=/usr/share/doc/freeswan-%{version} \
     FINALDOCDIR=/usr/share/doc/freeswan-%{version} \
     FINALEXAMPLECONFDIR=/usr/share/doc/freeswan-%{version} \
     FINALLIBEXECDIR=/usr/lib/ipsec \
     RCDIR=%{_initdir} \
     MANTREE=%{_mandir} install

# We don't want all users to have the same secrets file :)
rm -f ${RPM_BUILD_ROOT}/ipsec.secrets
cp -f ${RPM_SOURCE_DIR}/freeswan-1.9.secrets.proto ${RPM_BUILD_ROOT}/etc/ipsec.secrets

# We actually do want chkconfig to work properly...
rm -f ${RPM_BUILD_ROOT}%{_initdir}/ipsec || :
sed -e 's/^# chkconfig:.*$/# chkconfig: - 47 68/' programs/setup/setup > \
        ${RPM_BUILD_ROOT}%{_initdir}/ipsec
chmod 755 ${RPM_BUILD_ROOT}%{_initdir}/ipsec

# For x509
#install --strip x509patch-%{x509version}-freeswan-%{version}/fswcert/fswcert ${RPM_BUILD_ROOT}/usr/lib/ipsec
mkdir -pm 700 ${RPM_BUILD_ROOT}/etc/ipsec.d/cacerts
mkdir -pm 700 ${RPM_BUILD_ROOT}/etc/ipsec.d/crls

# Man pages.  For some reason they don't want to install where we want them
# They do install in the local directory.
for i in 1 2 3 4 5 6 7 8 9; do
   mkdir -pm 755 ${RPM_BUILD_ROOT}%{_mandir}/man$i
   for j in `find . -name \*.$i`; do
     cp -a $j ${RPM_BUILD_ROOT}%{_mandir}/man$i/
   done 
   chmod a+r ${RPM_BUILD_ROOT}%{_mandir}/man$i/* 2>/dev/null || :
done

# Seems FreeSWAN ships the man pages of .... bind-light
rm -f ${RPM_BUILD_ROOT}%{_mandir}/man3/lwres*

# Do the docs from the X509 patch
cp x509-%{x509version}-freeswan-%{version}/README doc/README.x509patch
cp x509-%{x509version}-freeswan-%{version}/CHANGES doc/CHANGES.x509patch
cp x509-%{x509version}-freeswan-%{version}/ipsec.secrets.template doc/ipsec.secrets.template.x509patch
# Clean out what we don't want from docs
rm -f doc/Makefile
rm -rf doc/manpage.d doc/presentations doc/src doc/utils


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%post
if test ! -e /dev/ipsec ; then
       mknod -m 0200 /dev/ipsec c 36 10 ;
fi
# create correct symlinks.
/sbin/chkconfig --add ipsec
/sbin/restart_maybe ipsec

%preun
if [ $1 = 0 ]; then
	%{_initdir}/ipsec stop 2>/dev/null || :
	chkconfig --del ipsec || :
fi

%files
%defattr(-,root,root)
%doc doc/* README CHANGES COPYING CREDITS
/usr/lib/ipsec
%config(noreplace) %attr(600,root,root) /etc/ipsec.secrets
%config(noreplace) %attr(600,root,root) /etc/ipsec.conf
%{_initdir}/*
/usr/share/man/*/*
/usr/sbin/ipsec
/etc/ipsec.d

%changelog
* Fri Dec  5 2003 Erlend Midttun <erlendbm at trustix dot com> 2.04-1tr
- Big rebuild

* Mon Dec  1 2003 Chr. Toldnes <christht at trustix dot org> 2.04-1tr
- New upstream version: 2.04

* Thu Oct 30 2003 Chr. Toldnes <christht at trustix dot org> 2.00-4tr
- Now make install does not fsck up the build box... (patch2)

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 2.00-3tr
- Big rebuild

* Fri May 16 2003 Erlend Midttun <erlendbm at trustix dot com> 2.00-2em
- Moved patch creation to a separate script shipped with tsl-utils.

* Wed May 14 2003 Erlend Midttun <erlendbm at trustix dot com> 2.00-1em
- New upstream.
- Now create kernel patch here if needed.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 1.99-3em
- Rebuilt against glibc 2.3.2.

* Mon Dec  9 2002 Erlend Midttun <erlendbm at trustix dot com> 1.99-2em
- Use _initdir.

* Thu Oct 30 2002 Erlend Midttun <erlendbm at trustix dot com>
- Fixed wrong path to IPSEC_DIR.

* Thu Sep 19 2002 Erlend Midttun <erlendbm at trustix dot com>
- Updated to 1.98b and X509 patch 0.9.15.
- Added some docs

* Fri Jan 11 2002 Christian H. Toldnes <christht at trustix dot com> 
- Now maybe we got the correct use of chkconfig....

* Wed Jan  9 2002 Lars Gaarden <larsg at trustix dot com>
- Merge x509-0.9.5 patch

* Thu Jan  3 2002 Christian H. Toldnes <christht at trustix dot com>
- Correct chkconfig line in new init script.

* Thu Nov  1 2001 Erlend Midttun <erlendbm at trustix dot com>
- Picked up 1.91 to fix memory leak.

* Fri Jun 13 2001 Erlend Midttun <erlendbm at trustix dot com>
- Updated serial when rebuilding for 1.5.

* Wed Mar 28 2001 Alexander Reelsen <ar at trustix dot com>
- Updated to 1.9, which fixes a memory leak

* Mon Jan 29 2001 Olaf Trygve Berglihn <olafb at trustix dot com>
- Fixed preun to only run chkconfig off and service stop if not
  upgrading.

* Fri Aug  4 2000 Per Ivar Paulsen <perp at trustix dot com>
- First Build For TSL 
